{$A-}
{
abcAVI Dinamic Link Library - brings the ability of reading and writing content
of informative tags (INFO tags) of AVI files.
Copyright (C) 2002 by Alexander Sorkin aka Kibi.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

22.05.2005
Alexander Sorkin aka Kibi
Authors homepage: http://kibi.ru
abcAVI software homepage: http://abcavi.kibi.ru

Last changes 22.05.2005
}
unit abcAVI_impl;

interface

uses  ComObj, abcAVI_TLB, SysUtils, Classes, StdVcl, ActiveX, GpHugeF, windows;
Type
  TFourCC = array [1..4] of char;
  TExtendedAVITags = class(TAutoObject, IExtendedAVITags)
  protected
    function ReadAVITags(File_Name: OleVariant; Parse_Mode: CParse_Mode;
      Max_Entries: SYSINT; out AVI_Info: OleVariant): HResult; safecall;
    function WriteAVITags(File_Name, AVI_Info: OleVariant): HResult; safecall;
    function ErrorCodeToStr(Error_Code: HResult): OleVariant; safecall;
    function NewTagsContainer: OleVariant; safecall;
    function GetInfo(AVI_Info: OleVariant; Type_ID: CInfo_Type_ID;
      Info_ID: SYSINT): OleVariant; safecall;
    function SetInfo(var AVI_Info: OleVariant; Type_ID: CInfo_Type_ID;
      Info_ID: SYSINT; New_Value: OleVariant): HResult; safecall;
    function FccToStr(FourCC: OleVariant): OleVariant; safecall;
    { Protected declarations }
  end;
  function Round(x:real):int64;
Const
   Tags_FourCC: array [0..IDT_max] of TFourCC = (
      'INAM','IART','ICOP','IPRD','ICRD','IGNR','ISGN','ISBJ','IKEY','ICMT',
      'IWRI','IPRO','ICNM','IPDS','IEDT','IMUS','ICDS','ISTD','ICNT','ICMS',
      'IDST','ILNG','IRTD','ISTR','ISFT','IDIT','IENG','ITCH','IWEB','IPRT',
      'IFRM','ISRF','IMED','ISRC','IARL','IMIU','IMIT','IDIM','ISHP','IPLT',
      'ILGT','IDPI','ICRP','ILGU','ILIU','IWMU','IMBI','IMBU','ICAS','IAS1',
      'IAS2','IAS3','IAS4','IAS5','IAS6','IAS7','IAS8','IAS9','ISMP','IBSU',
      'IENC','IRIP'
      );
   Other_Tags_FourCC: array [IDO_MovieID_TITL..IDO_MovieID_CODE] of TFourCC = (
      'TITL','DIRC','YEAR','GENR','COMM','LANG','AGES','PRT1','PRT2','STAR',
      'CODE'
      );

   Video_Info_Desc: array [0..IDV_max] of String = (
      'IDV_Codec_FourCC',
      'IDV_Handler_FourCC',
      'IDV_Width',
      'IDV_Height',
      'IDV_Aspect_Ratio',
      'IDV_Frame_Proportion',
      'IDV_Bit_Depth',
      'IDV_Frames',
      'IDV_Key_Frames',
      'IDV_Frame_Rate',
      'IDV_Data_Rate',
      'IDV_Maximum_Data_Rate',
      'IDV_Effective_Bits_Per_Pixel',
      'IDV_Effective_Bits_Per_Frame_3x4',
      'IDV_Compression',
      'IDV_Power_Of_Compression',
      'IDV_Duration',
      'IDV_Rate',
      'IDV_Scale',
      'IDV_Size'
      );
   Audio_Info_Desc: array [0..IDA_max] of String = (
      'IDA_Codec_TwoCC',
      'IDA_Data_Rate',
      'IDA_Sampling_Rate',
      'IDA_Bit_Depth',
      'IDA_Channels',
      'IDA_Duration',
      'IDA_Language',
      'IDA_Rate',
      'IDA_Scale',
      'IDA_Length',
      'IDA_Size',
      'IDA_Sample_Size'
   );
type
   TINFO_tags = array [0..IDT_max] of WideString;
   TVideo_Info = array [0..IDT_max] of WideString;
   TAudio_Info = array [0..IDA_max] of WideString;
   TOther_tags = array [0..IDO_max] of WideString;
   TFlagInfo = record
      flag:longword;
      name:string;
   end;
Const
   FourCC_zero : TFourCC = (#0,#0,#0,#0);
   x_dec = 0;
   x_hex_b = 1;
   x_hex_w = 2;
   x_hex_dw = 3;
   x_str = 4;
   x_null = 5;
   x_fcc = 6;
   x_dec_64 = 7;

implementation

uses ComServ;

function Round(x:real):int64;
begin
   if frac(x)<0.5 then result:=trunc(x) else result:=trunc(x)+1;
end;
function TExtendedAVITags.ReadAVITags(File_Name: OleVariant;
  Parse_Mode: CParse_Mode; Max_Entries: SYSINT;
  out AVI_Info: OleVariant): HResult;
Type Tlist_info=record  // structure to remember enclosed RIFF lists
        value:Longword;  // old value (needed for reading info)
        counter:Longword; // counter of bytes read
     end;
var info_tags:TINFO_tags; // array to hold tags information
    Other_tags:TOther_tags; // array to hold other tags info (IDivX, MovieID, JUNK etc)
    Video_Info:TVideo_Info; // array to hold info on video stream
    Audio1_Info:TAudio_Info; // array to hold info on audio stream 1
    Audio2_Info:TAudio_Info; // array to hold info on audio stream 2
    Audio3_Info:TAudio_Info; // array to hold info on audio stream 3
    audio_stream_counter:byte; // current audio stream number
    video_stream_counter:byte; // current video stream number
    dv_video:boolean; // flag "VFW not compatibile stream" - iavs
    Parsed_Super_Index:boolean; // flag "skip idx1 if super index was parsed already"
    riff_name,list_name:TFourCC; // name of current list
    stream_type:TFourCC; // type of current stream data
    buffer:string; // read buffer
    temp_tree:TStringList; // adding to TStringList is much more faster then adding to simple string ! (more then 10 times)
    res:Longword;
    avi_length,riff_length:Longword; // unsigned 32-bit int
    movi_size,file_size,last_pos:int64;
    x:integer;
    list_deep:byte;
    lists:array [1..10] of Tlist_info; // information about enclosed RIFF lists
    Attributes:word; // AVI file attributes
    in_big_file:TGPHugeFile;
    movi_end:int64;
    movi_counter:longword;
    ignore_errors, // flag "ignore errors"
    build_tree, // flag "create tree of structure"
    parse_index, // flag "parse idx1 section"
    parse_junk, // flag "parse JUNK sections"
    parse_movi, // flag "parse movi section"
    Read_IDivX, // flag "read MovieID tags"
    Read_MovieID, // flag "read IDivX tags"
    Parse_Premier, // flag "parse Adobe Premier tag"
    tech_info:boolean; // flag "read/calculate tech info on video and audio streams"
procedure inc_counters(count:longword);
   var b:byte;
   begin
      for b:=1 to list_deep do inc(lists[b].counter,count);
   end;
procedure check_counters;
   var b,z:byte;
   begin
      z:=list_deep;
      for b:=1 to z do // check the counters
         if lists[b].counter>=lists[b].value then
            dec(list_deep); // decrease list deep
   end;
function fcc2str(info:TFourCC):string;
   var x:byte;
   begin
      result:='';
      for x:=1 to 4 do if info[x]<>#0 then result:=result+info[x];
   end;
function byte_array2hex_str(barray:array of byte):string;
var
   temp:string;
   x:integer;
begin
   setlength(temp,length(barray)*3);
   temp:=inttohex(barray[0],2);
   for x:=low(barray)+1 to high(barray)-1 do begin
      if (x>Max_Entries) and (Max_Entries>4) then begin
         temp:=temp+'...';
         break;
      end;
      temp:=temp+' '+inttohex(barray[x],2);
   end;
   result:=temp;
end;
function deep2tab(deep:byte):string;
   var x:byte;
   begin
      result:='';
      for x:=1 to deep do result:=result+#9;
   end;
function log_error(error:TOleEnum):boolean;
   begin
      if (Ignore_Errors) and (error<>PE_Not_RIFF_Error) and (error<>PE_Not_AVI_Error) then begin
         ReadAviTags:=PE_Errors_Ignored;
         log_error:=false;
      end else begin
         ReadAviTags:=error;
         in_big_file.Free;
         temp_tree.Free;
         log_error:=true;
      end;
   end;
procedure recognize_tag; // routine for recognizing RIFF INFO tags
   var x:integer;
   begin
      for x:=0 to IDT_max do
         if riff_name=Tags_FourCC[x] then begin
            if buffer[length(buffer)-2]=#0 then begin // double #0 detected
               info_tags[x]:=buffer;
               setlength(info_tags[x],length(info_tags[x])-3);
            end else begin // normal end of string
               info_tags[x]:=buffer;
               setlength(info_tags[x],length(info_tags[x])-2);
            end;
            break
         end;
   end;
procedure recognize_mid; // routine for recognizing MovieID tags
   var x:integer;
   begin
      for x:=IDO_MovieID_TITL to IDO_MovieID_CODE do
         if riff_name=Other_Tags_FourCC[x] then begin
            other_tags[x]:=buffer;
            break
         end;
   end;

procedure add_flags(offset:longword; deep:byte; cur_flags:longword; known_flags:array of TFlagInfo; x_type:byte);
   var
      dwflags:longword;
      b:byte;
      temp64:int64;
   begin
      dwflags:=cur_flags; // set all bits
      temp64:=last_pos+offset+8;
      for b:=low(known_flags) to high(known_flags) do begin
         if (cur_flags and known_flags[b].flag) = known_flags[b].flag then
            case x_type of
               1:temp_tree.Add(format('%0:.12d: %1:s[%2:s]: $(%2:s): 0x%3:.2x',[int64(temp64),deep2tab(deep),known_flags[b].name,known_flags[b].flag]));
               2:temp_tree.Add(format('%0:.12d: %1:s[%2:s]: $(%2:s): 0x%3:.4x',[int64(temp64),deep2tab(deep),known_flags[b].name,known_flags[b].flag]));
            else
               temp_tree.Add(format('%0:.12d: %1:s[%2:s]: $(%2:s): 0x%3:.8x',[int64(temp64),deep2tab(deep),known_flags[b].name,known_flags[b].flag]));
            end;
         dwflags:=dwflags and (not known_flags[b].flag); // discard flag bits
      end;
      if dwflags>0 then
         case x_type of
            1:temp_tree.Add(format('%0:.12d: %1:s[%2:s]: $(%2:s): 0x%3:.2x',[int64(temp64),deep2tab(deep),'UNKNOWN_FLAG',dwflags]));
            2:temp_tree.Add(format('%0:.12d: %1:s[%2:s]: $(%2:s): 0x%3:.4x',[int64(temp64),deep2tab(deep),'UNKNOWN_FLAG',dwflags]));
         else
            temp_tree.Add(format('%0:.12d: %1:s[%2:s]: $(%2:s): 0x%3:.8x',[int64(temp64),deep2tab(deep),'UNKNOWN_FLAG',dwflags]));
         end;
   end;
procedure add_unknown_info(r_size:longword;deep:byte);
   var
      temp:array of byte;
      temp64:int64;
   begin
      temp64:=last_pos+8+r_size;
      if longword(length(buffer)-1)>r_size then begin
         setlength(temp,longword(length(buffer))-r_size);
         Move(buffer[r_size+1],temp[0],length(temp)-1);
         temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:s',[int64(temp64),deep2tab(deep),'Unknown Info',length(temp)-1,byte_array2hex_str(temp)]));
      end;
   end;
procedure add_info(cur_offset:longword; cur_deep:byte; info_name:string; const value; size:longword; x_type:byte);
   var temp64:int64;
       format_string:string;
   begin
      temp64:=last_pos+8+cur_offset;
      if size>0
         then format_string:='%0:.12d: %1:s[%2:s %3:d]: $(%2:s)'
         else format_string:='%0:.12d: %1:s[%2:s]: $(%2:s)';
      case x_type of
         x_dec:   temp_tree.Add(format(format_string+': %4:d',[int64(temp64),deep2tab(cur_deep),info_name,size,integer(value)]));
         x_hex_b: temp_tree.Add(format(format_string+': 0x%4:.2x',[int64(temp64),deep2tab(cur_deep),info_name,size,byte(value)]));
         x_hex_w: temp_tree.Add(format(format_string+': 0x%4:.4x',[int64(temp64),deep2tab(cur_deep),info_name,size,word(value)]));
         x_hex_dw:temp_tree.Add(format(format_string+': 0x%4:.8x',[int64(temp64),deep2tab(cur_deep),info_name,size,longword(value)]));
         x_str:   temp_tree.Add(format(format_string+': %4:s',[int64(temp64),deep2tab(cur_deep),info_name,size,string(value)]));
         x_fcc:   temp_tree.Add(format(format_string+': %4:s',[int64(temp64),deep2tab(cur_deep),info_name,size,fcc2str(TFourCC(value))]));
         x_null:  temp_tree.Add(format(format_string,[int64(temp64),deep2tab(cur_deep),info_name,size]));
         x_dec_64:temp_tree.Add(format(format_string+': %4:d',[int64(temp64),deep2tab(cur_deep),info_name,size,int64(value)]));
      end;
   end;
procedure Process_avih; // parse avih chunk
   type
      Tavih=record
         dwMicroSecPerFrame:longword;
         dwMaxBytesPerSec:longword;
         dwPaddingGranularity:longword;
         dwFlags:longword;
         dwTotalFrames:longword;
         dwInitialFrames:longword;
         dwStreams:longword;
         dwSuggestedBufferSize:longword;
         dwWidth:longword;
         dwHeight:longword;
         dwScale:longword;
         dwRate:longword;
         dwStart:longword;
         dwLength:longword;
      end;
   var
      avih:Tavih;
      real_size:longword;
   const
      avih_flags:array[1..6]of TFlagInfo=(
         (flag:$00000010;name:'AVIF_HASINDEX'),
         (flag:$00000020;name:'AVIF_MUSTUSEINDEX'),
         (flag:$00000100;name:'AVIF_ISINTERLEAVED'),
         (flag:$00000800;name:'AVIF_TRUSTCKTYPE'),
         (flag:$00010000;name:'AVIF_WASCAPTUREFILE'),
         (flag:$00020000;name:'AVIF_COPYRIGHTED')
      );
   begin
      if length(buffer)-1>=sizeof(avih)
         then real_size:=sizeof(avih)
         else real_size:=length(buffer)-1;
      Move(buffer[1],avih,real_size);
      if Build_Tree then begin
         if real_size>=4 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+8),deep2tab(list_deep+1),'dwMicroSecPerFrame',4,avih.dwMicroSecPerFrame]));
         if real_size>=8 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+12),deep2tab(list_deep+1),'dwMaxBytesPerSec',4,avih.dwMaxBytesPerSec]));
         if real_size>=12 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+16),deep2tab(list_deep+1),'dwPaddingGranularity',4,avih.dwPaddingGranularity]));
         if real_size>=16 then begin
            temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+20),deep2tab(list_deep+1),'dwFlags',4,avih.dwFlags]));
            add_flags(12,list_deep+2,avih.dwFlags,avih_flags,sizeof(avih.dwFlags));
         end;
         if real_size>=20 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+24),deep2tab(list_deep+1),'dwTotalFrames',4,avih.dwTotalFrames]));
         if real_size>=24 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+28),deep2tab(list_deep+1),'dwInitialFrames',4,avih.dwInitialFrames]));
         if real_size>=28 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+32),deep2tab(list_deep+1),'dwStreams',4,avih.dwStreams]));
         if real_size>=32 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+36),deep2tab(list_deep+1),'dwSuggestedBufferSize',4,avih.dwSuggestedBufferSize]));
         if real_size>=36 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+40),deep2tab(list_deep+1),'dwWidth',4,avih.dwWidth]));
         if real_size>=40 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+44),deep2tab(list_deep+1),'dwHeight',4,avih.dwHeight]));
         if real_size>=44 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+48),deep2tab(list_deep+1),'dwScale',4,avih.dwScale]));
         if real_size>=48 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+52),deep2tab(list_deep+1),'dwRate',4,avih.dwRate]));
         if real_size>=52 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+56),deep2tab(list_deep+1),'dwStart',4,avih.dwStart]));
         if real_size>=56 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+60),deep2tab(list_deep+1),'dwLength',4,avih.dwLength]));
         add_unknown_info(real_size,list_deep+1);
      end;
      // extract information on video
      video_info[IDV_Frames]:=inttostr(avih.dwTotalFrames);
      video_info[IDV_Width]:=inttostr(avih.dwWidth);
      video_info[IDV_Height]:=inttostr(avih.dwHeight);
   end;
procedure Process_strh; // parse strh chunk
   type
      Tstrh=record
         fccType:TFourCC;
         fccHandler:longword;
         dwFlags:longword;
         wPriority:word;
         wLanguage:word;
         dwInitialFrames:longword;
         dwScale:longword;
         dwRate:longword;
         dwStart:longword;
         dwLength:longword;
         dwSuggestedBufferSize:longword;
         dwQuality:longword;
         dwSampleSize:longword;
         rcFrame:array[1..4]of word;
      end;
   const
      strh_flags:array[1..2]of TFlagInfo=(
         (flag:$00000001;name:'AVISF_DISABLED'),
         (flag:$00010000;name:'AVISF_VIDEO_PALCHANGES')
      );
   var
      strh:Tstrh;
      real_size:longword;
      cur_size:longword;
      sum_size:longword;
   begin
      if length(buffer)-1>=sizeof(strh)
         then real_size:=sizeof(strh)
         else real_size:=length(buffer)-1;
      Move(buffer[1],strh,real_size);
      if Build_Tree then begin
         sum_size:=0; cur_size:=sizeof(strh.fccType);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'fccType',strh.fccType,cur_size,x_fcc);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.fccHandler);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'fccType',strh.fccHandler,cur_size,x_hex_dw);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.dwFlags);
         if real_size>=sum_size+cur_size then begin
            add_info(sum_size,list_deep+1,'dwFlags',strh.dwFlags,cur_size,x_hex_dw);
            add_flags(8,list_deep+2,strh.dwFlags,strh_flags,sizeof(strh.dwFlags));
         end;
         inc(sum_size,cur_size); cur_size:=sizeof(strh.wPriority);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'wPriority',strh.wPriority,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.wLanguage);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'wLanguage',strh.wLanguage,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.dwInitialFrames);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwInitialFrames',strh.dwInitialFrames,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.dwScale);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwScale',strh.dwScale,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.dwRate);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwRate',strh.dwRate,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.dwStart);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwStart',strh.dwStart,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.dwLength);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwLength',strh.dwLength,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.dwSuggestedBufferSize);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwSuggestedBufferSize',strh.dwSuggestedBufferSize,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.dwQuality);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwQuality',strh.dwQuality,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.dwSampleSize);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwSampleSize',strh.dwSampleSize,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(strh.rcFrame);
         if real_size>=sum_size+cur_size then begin
            add_info(sum_size,list_deep+1,'rcFrame',null,cur_size,x_null);
            cur_size:=sizeof(strh.rcFrame[1]);
            add_info(sum_size,list_deep+2,'Left',strh.rcFrame[1],cur_size,x_dec);
            inc(sum_size,cur_size); cur_size:=sizeof(strh.rcFrame[2]);
            add_info(sum_size,list_deep+2,'Top',strh.rcFrame[2],cur_size,x_dec);
            inc(sum_size,cur_size); cur_size:=sizeof(strh.rcFrame[3]);
            add_info(sum_size,list_deep+2,'Right',strh.rcFrame[3],cur_size,x_dec);
            inc(sum_size,cur_size); cur_size:=sizeof(strh.rcFrame[4]);
            add_info(sum_size,list_deep+2,'Bottom',strh.rcFrame[4],cur_size,x_dec);
         end;
         add_unknown_info(real_size,list_deep+1);
      end;
      // extract information on stream
      stream_type:=strh.fccType;
      if (stream_type='vids') or (stream_type='iavs') then begin
         inc(video_stream_counter);
         if (video_stream_counter=1) then begin
            video_info[IDV_Frames]:=inttostr(strh.dwLength);
            video_info[IDV_Rate]:=inttostr(strh.dwRate);
            video_info[IDV_Scale]:=inttostr(strh.dwScale);
            if strh.dwScale*strh.dwRate>0 then begin
               Video_Info[IDV_Frame_Rate]:=format('%.4f',[strh.dwRate/strh.dwScale]);
               Video_Info[IDV_Duration]:=inttostr(round((strh.dwScale/strh.dwRate)*strh.dwLength*1000));
            end;
            video_info[IDV_Handler_FourCC]:=format('0x%.8x',[strh.fccHandler]);
         end;
      end;
      if (stream_type='iavs') then dv_video:=true;
      if stream_type='auds' then begin
         inc(audio_stream_counter);
         if audio_stream_counter=1 then begin
            Audio1_Info[IDA_Language]:=inttostr(strh.wLanguage);
            Audio1_Info[IDA_Rate]:=inttostr(strh.dwRate);
            Audio1_Info[IDA_Scale]:=inttostr(strh.dwScale);
            Audio1_Info[IDA_Length]:=inttostr(strh.dwLength);
            Audio1_Info[IDA_Sample_Size]:=inttostr(strh.dwSampleSize);
            // if strh.dwScale*strh.dwRate>0 then Audio1_Info[IDA_Duration]:=inttostr(round((strh.dwScale/strh.dwRate)*strh.dwLength*1000));
         end;
         if audio_stream_counter=2 then begin
            Audio2_Info[IDA_Language]:=inttostr(strh.wLanguage);
            Audio2_Info[IDA_Rate]:=inttostr(strh.dwRate);
            Audio2_Info[IDA_Scale]:=inttostr(strh.dwScale);
            Audio2_Info[IDA_Length]:=inttostr(strh.dwLength);
            Audio2_Info[IDA_Sample_Size]:=inttostr(strh.dwSampleSize);
            // if strh.dwScale*strh.dwRate>0 then Audio2_Info[IDA_Duration]:=inttostr(round((strh.dwScale/strh.dwRate)*strh.dwLength*1000));
         end;
         if audio_stream_counter=3 then begin
            Audio3_Info[IDA_Language]:=inttostr(strh.wLanguage);
            Audio3_Info[IDA_Rate]:=inttostr(strh.dwRate);
            Audio3_Info[IDA_Scale]:=inttostr(strh.dwScale);
            Audio3_Info[IDA_Length]:=inttostr(strh.dwLength);
            Audio3_Info[IDA_Sample_Size]:=inttostr(strh.dwSampleSize);
            // if strh.dwScale*strh.dwRate>0 then Audio3_Info[IDA_Duration]:=inttostr(round((strh.dwScale/strh.dwRate)*strh.dwLength*1000));
         end;
      end;
   end;
procedure Process_strf; // parse strf chunk
   type
      Tstrf_auds=record
         wFormatTag:word;
         wChannels:word;
         dwSamplesPerSec:longword;
         dwAvgBytesPerSec:longword;
         wBlockAlign:word;
         wBitsPerSample:word;
         wSize:word;
      end;
      TAuds50=record
         general:Tstrf_auds; // 18 bytes
         fwHeadLayer:word;
         dwHeadBitrate:longword;
         fwHeadMode:word;
         fwHeadModeExt:word;
         wHeadEmphasis:word;
         fwHeadFlags:word;
         qwPTS:Int64;
      end;
      TAuds55=record
         general:Tstrf_auds; // 18 bytes
         wID:word;
         fwFlags:word;
         wBlockSize:word;
         wFramesPerBlock:word;
         wCodecDelay:word;
      end;
      Tstrf_vids=record
         dwSize:longword;
         lWidth:longint;
         lHeight:longint;
         wPlanes:word;
         wBitCount:word;
         fccCompression:longword;
         dwSizeImage:longword;
         lXPelsPerMeter:longint;
         lYPelsPerMeter:longint;
         dwClrUsed:longword;
         dwClrImportant:longword;
      end;
      Tstrf_iavs=record
         dwDVAAuxSrc:longword;
         dwDVAAuxCtl:longword;
         dwDVAAuxSrc1:longword;
         dwDVAAuxCtl1:longword;
         dwDVVAuxSrc:longword;
         dwDVVAuxCtl:longword;
         dwDVReserved1:longword;
         dwDVReserved2:longword;
      end;
   const
      headmode_flags:array [1..4] of TFlagInfo=(
         (flag:$0001;name:'ACM_MPEG_STEREO'),
         (flag:$0002;name:'ACM_MPEG_JOINTSTEREO'),
         (flag:$0004;name:'ACM_MPEG_DUALCHANNEL'),
         (flag:$0008;name:'ACM_MPEG_SINGLECHANNEL')
      );
      head_flags:array [1..5] of TFlagInfo=(
         (flag:$0001;name:'ACM_MPEG_PRIVATEBIT'),
         (flag:$0002;name:'ACM_MPEG_COPYRIGHT'),
         (flag:$0004;name:'ACM_MPEG_ORIGINALHOME'),
         (flag:$0008;name:'ACM_MPEG_PROTECTIONBIT'),
         (flag:$0010;name:'ACM_MPEG_ID_MPEG1')
      );
      mpeglayer_flags:array [1..3] of TFlagInfo=(
         (flag:$0001;name:'ACM_MPEG_LAYER1'),
         (flag:$0002;name:'ACM_MPEG_LAYER2'),
         (flag:$0004;name:'ACM_MPEG_LAYER3')
      );
      heademphasis_flags:array [1..4] of TFlagInfo=(
         (flag:$0001;name:'ACM_MPEG_NO_EMPHASIS'),
         (flag:$0002;name:'ACM_MPEG_50_15_MS_EMPHASIS'),
         (flag:$0003;name:'ACM_MPEG_RESERVED'),
         (flag:$0004;name:'ACM_MPEG_CCITT_J_17')
      );
      headmodeext12_flags:array [1..4] of TFlagInfo=(
         (flag:$0001;name:'ACM_MPEG_SUBBANDS_4_31_IN_INTENSITY_STEREO'),
         (flag:$0002;name:'ACM_MPEG_SUBBANDS_8_31_IN_INTENSITY_STEREO'),
         (flag:$0004;name:'ACM_MPEG_SUBBANDS_12_31_IN_INTENSITY_STEREO'),
         (flag:$0008;name:'ACM_MPEG_SUBBANDS_16_31_IN_INTENSITY_STEREO')
      );
      headmodeext3_flags:array [1..4] of TFlagInfo=(
         (flag:$0001;name:'ACM_MPEG_NO_INTENSITY_OR_MS_STEREO'),
         (flag:$0002;name:'ACM_MPEG_INTENSITY_STEREO'),
         (flag:$0004;name:'ACM_MPEG_MS_STEREO'),
         (flag:$0008;name:'ACM_MPEG_BOTH_INTENSITY_AND_MS_STEREO')
      );
      mpegid_flags:array [1..3] of TFlagInfo=(
         (flag:$0001;name:'ACM_MPEG_UNKNOWN'),
         (flag:$0002;name:'ACM_MPEG_COMMON'),
         (flag:$0003;name:'ACM_MPEG_CONSTANT_FRAME_SIZE')
      );
      mpegpadding_flags:array [1..3] of TFlagInfo=(
         (flag:$0001;name:'ACM_MPEG_ISO_PADDING'),
         (flag:$0002;name:'ACM_MPEG_PADDING_ON'),
         (flag:$0003;name:'ACM_MPEG_PADDING_OFF')
      );
   var
      real_size:longword;
      strf_auds:Tstrf_auds;
      strf_auds_50:TAuds50;
      strf_auds_55:TAuds55;
      strf_vids:Tstrf_vids;
      strf_iavs:Tstrf_iavs;
   begin
      if stream_type='vids' then begin
         if length(buffer)-1>=sizeof(strf_vids)
            then real_size:=sizeof(strf_vids)
            else real_size:=length(buffer)-1;
         Move(buffer[1],strf_vids,real_size);
         if Build_Tree then begin
            if real_size>=4 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+8),deep2tab(list_deep+1),'dwSize',4,strf_vids.dwSize]));
            if real_size>=8 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+12),deep2tab(list_deep+1),'lWidth',4,strf_vids.lWidth]));
            if real_size>=12 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+16),deep2tab(list_deep+1),'lHeight',4,strf_vids.lHeight]));
            if real_size>=14 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+20),deep2tab(list_deep+1),'wPlanes',2,strf_vids.wPlanes]));
            if real_size>=16 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+22),deep2tab(list_deep+1),'wBitCount',2,strf_vids.wBitCount]));
            if real_size>=20 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+24),deep2tab(list_deep+1),'fccCompression',4,strf_vids.fccCompression]));
            if real_size>=24 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+28),deep2tab(list_deep+1),'dwSizeImage',4,strf_vids.dwSizeImage]));
            if real_size>=28 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+32),deep2tab(list_deep+1),'lXPelsPerMeter',4,strf_vids.lXPelsPerMeter]));
            if real_size>=32 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+36),deep2tab(list_deep+1),'lYPelsPerMeter',4,strf_vids.lYPelsPerMeter]));
            if real_size>=36 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+40),deep2tab(list_deep+1),'dwClrUsed',4,strf_vids.dwClrUsed]));
            if real_size>=40 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+44),deep2tab(list_deep+1),'dwClrImportant',4,strf_vids.dwClrImportant]));
            add_unknown_info(real_size,list_deep+1);
         end;
         // extract information on video streams
         if (video_stream_counter=1) then begin
            video_info[IDV_Bit_Depth]:=inttostr(strf_vids.wBitCount);
            video_info[IDV_Codec_FourCC]:=format('0x%.8x',[strf_vids.fccCompression]);
            video_info[IDV_Width]:=inttostr(abs(strf_vids.lWidth));
            video_info[IDV_Height]:=inttostr(abs(strf_vids.lHeight));
         end;
      end;
      if stream_type='auds' then begin
         if length(buffer)-1>=sizeof(strf_auds)
            then real_size:=sizeof(strf_auds)
            else real_size:=length(buffer)-1;
         Move(buffer[1],strf_auds,real_size);
         if Build_Tree then begin
            if real_size>=2 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.4x',[int64(last_pos+8),deep2tab(list_deep+1),'wFormatTag',2,strf_auds.wFormatTag]));
            if real_size>=4 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+10),deep2tab(list_deep+1),'wChannels',2,strf_auds.wChannels]));
            if real_size>=8 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+12),deep2tab(list_deep+1),'dwSamplesPerSec',4,strf_auds.dwSamplesPerSec]));
            if real_size>=12 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+16),deep2tab(list_deep+1),'dwAvgBytesPerSec',4,strf_auds.dwAvgBytesPerSec]));
            if real_size>=14 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+20),deep2tab(list_deep+1),'wBlockAlign',2,strf_auds.wBlockAlign]));
            if real_size>=16 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+22),deep2tab(list_deep+1),'wBitsPerSample',2,strf_auds.wBitsPerSample]));
            if real_size>=18 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+24),deep2tab(list_deep+1),'wSize',2,strf_auds.wSize]));
            if strf_auds.wFormatTag=$50 then begin // show additional info for MPEG audio
               if length(buffer)-1>=sizeof(strf_auds_50)
                  then real_size:=sizeof(strf_auds_50)
                  else real_size:=length(buffer)-1;
               Move(buffer[1],strf_auds_50,real_size);
               if real_size>=20 then begin
                  temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.4x',[int64(last_pos+26),deep2tab(list_deep+2),'fwHeadLayer',2,strf_auds_50.fwHeadLayer]));
                  add_flags(18,list_deep+3,strf_auds_50.fwHeadLayer,mpeglayer_flags,sizeof(strf_auds_50.fwHeadLayer));
               end;
               if real_size>=24 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+28),deep2tab(list_deep+2),'dwHeadBitrate',4,strf_auds_50.dwHeadBitrate]));
               if real_size>=26 then begin
                  temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.4x',[int64(last_pos+32),deep2tab(list_deep+2),'fwHeadMode',2,strf_auds_50.fwHeadMode]));
                  add_flags(24,list_deep+3,strf_auds_50.fwHeadMode,headmode_flags,sizeof(strf_auds_50.fwHeadMode));
               end;
               if real_size>=28 then begin
                  temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.4x',[int64(last_pos+34),deep2tab(list_deep+2),'fwHeadModeExt',2,strf_auds_50.fwHeadModeExt]));
                  if (strf_auds_50.fwHeadLayer=1) or (strf_auds_50.fwHeadLayer=2) {layer 1,2} then add_flags(26,list_deep+3,strf_auds_50.fwHeadModeExt,headmodeext12_flags,sizeof(strf_auds_50.fwHeadModeExt));
                  if (strf_auds_50.fwHeadLayer=4) {layer 3} then add_flags(26,list_deep+3,strf_auds_50.fwHeadModeExt,headmodeext3_flags,sizeof(strf_auds_50.fwHeadModeExt));
               end;
               if real_size>=30 then begin
                  temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+36),deep2tab(list_deep+2),'wHeadEmphasis',2,strf_auds_50.wHeadEmphasis]));
                  add_flags(28,list_deep+3,strf_auds_50.wHeadEmphasis,heademphasis_flags,sizeof(strf_auds_50.wHeadEmphasis));
               end;
               if real_size>=32 then begin
                  temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.4x',[int64(last_pos+38),deep2tab(list_deep+2),'fwHeadFlags',2,strf_auds_50.fwHeadFlags]));
                  add_flags(30,list_deep+3,strf_auds_50.fwHeadFlags,head_flags,sizeof(strf_auds_50.fwHeadFlags));
               end;
               if real_size>=40 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+40),deep2tab(list_deep+2),'qwPTS',8,strf_auds_50.qwPTS]));
            end;
            if strf_auds.wFormatTag=$55 then begin // show additional info for MP3 audio
               if length(buffer)-1>=sizeof(strf_auds_55)
                  then real_size:=sizeof(strf_auds_55)
                  else real_size:=length(buffer)-1;
               Move(buffer[1],strf_auds_55,real_size);
               if real_size>=20 then begin
                  temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+26),deep2tab(list_deep+2),'wID',2,strf_auds_55.wID]));
                  add_flags(18,list_deep+3,strf_auds_55.wID,mpegid_flags,sizeof(strf_auds_55.wID));
               end;
               if real_size>=22 then begin
                  temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+28),deep2tab(list_deep+2),'fwFlags',2,strf_auds_55.fwFlags]));
                  add_flags(20,list_deep+3,strf_auds_55.fwFlags,mpegpadding_flags,sizeof(strf_auds_55.fwFlags));
               end;
               if real_size>=24 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+30),deep2tab(list_deep+2),'wBlockSize',2,strf_auds_55.wBlockSize]));
               if real_size>=26 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+32),deep2tab(list_deep+2),'wFramesPerBlock',2,strf_auds_55.wFramesPerBlock]));
               if real_size>=28 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+34),deep2tab(list_deep+2),'wCodecDelay',2,strf_auds_55.wCodecDelay]));
            end;
            add_unknown_info(real_size,list_deep+2);
         end;
         // extract information on audio streams
         if audio_stream_counter=1 then begin
            audio1_info[IDA_Data_Rate]:=inttostr(strf_auds.dwAvgBytesPerSec*8);
            audio1_info[IDA_Sampling_Rate]:=inttostr(strf_auds.dwSamplesPerSec);
            audio1_info[IDA_Bit_Depth]:=inttostr(strf_auds.wBitsPerSample);
            audio1_info[IDA_Codec_TwoCC]:=inttostr(strf_auds.wFormatTag);
            audio1_info[IDA_Channels]:=inttostr(strf_auds.wChannels);
         end;
         if audio_stream_counter=2 then begin
            audio2_info[IDA_Data_Rate]:=inttostr(strf_auds.dwAvgBytesPerSec*8);
            audio2_info[IDA_Sampling_Rate]:=inttostr(strf_auds.dwSamplesPerSec);
            audio2_info[IDA_Bit_Depth]:=inttostr(strf_auds.wBitsPerSample);
            audio2_info[IDA_Codec_TwoCC]:=inttostr(strf_auds.wFormatTag);
            audio2_info[IDA_Channels]:=inttostr(strf_auds.wChannels);
         end;
         if audio_stream_counter=3 then begin
            audio3_info[IDA_Data_Rate]:=inttostr(strf_auds.dwAvgBytesPerSec*8);
            audio3_info[IDA_Sampling_Rate]:=inttostr(strf_auds.dwSamplesPerSec);
            audio3_info[IDA_Bit_Depth]:=inttostr(strf_auds.wBitsPerSample);
            audio3_info[IDA_Codec_TwoCC]:=inttostr(strf_auds.wFormatTag);
            audio3_info[IDA_Channels]:=inttostr(strf_auds.wChannels);
         end;
      end;
      if stream_type='iavs' then begin
         if length(buffer)-1>=sizeof(strf_iavs)
            then real_size:=sizeof(strf_iavs)
            else real_size:=length(buffer)-1;
         Move(buffer[1],strf_iavs,real_size);
         if Build_Tree then begin
            if real_size>=4 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+8),deep2tab(list_deep+1),'dwDVAAuxSrc',4,strf_iavs.dwDVAAuxSrc]));
            if real_size>=8 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+12),deep2tab(list_deep+1),'dwDVAAuxCtl',4,strf_iavs.dwDVAAuxCtl]));
            if real_size>=12 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+16),deep2tab(list_deep+1),'dwDVAAuxSrc1',4,strf_iavs.dwDVAAuxSrc1]));
            if real_size>=16 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+20),deep2tab(list_deep+1),'dwDVAAuxCtl1',4,strf_iavs.dwDVAAuxCtl1]));
            if real_size>=20 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+24),deep2tab(list_deep+1),'dwDVVAuxSrc',4,strf_iavs.dwDVVAuxSrc]));
            if real_size>=24 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+28),deep2tab(list_deep+1),'dwDVVAuxCtl',4,strf_iavs.dwDVVAuxCtl]));
            if real_size>=28 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+32),deep2tab(list_deep+1),'dwDVReserved1',4,strf_iavs.dwDVReserved1]));
            if real_size>=32 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): 0x%4:.8x',[int64(last_pos+36),deep2tab(list_deep+1),'dwDVReserved2',4,strf_iavs.dwDVReserved2]));
            add_unknown_info(real_size,list_deep+1);
         end;
      end;
   end;
procedure Process_dmlh; // parse dmlh chunk
   type
      Tdmlh=record
         dwTotalFrames:longword;
      end;
   var
      dmlh:Tdmlh;
      real_size, vrate, vscale:longword;
   begin
      if length(buffer)-1>=sizeof(dmlh)
         then real_size:=sizeof(dmlh)
         else real_size:=length(buffer)-1;
      Move(buffer[1],dmlh,real_size);
      if Build_Tree then begin
         if real_size>=4 then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s): %4:d',[int64(last_pos+8),deep2tab(list_deep+1),'dwTotalFrames',4,dmlh.dwTotalFrames]));
         if longword(length(buffer)-1)>real_size then add_info(real_size,list_deep+1,'dmlh_JUNK',null,longword(length(buffer))-1-real_size,x_null);
      end;
      // extract information on video
      video_info[IDV_Frames]:=inttostr(dmlh.dwTotalFrames);
      try
         vrate:=strtoint(Video_Info[IDV_Rate]);
         vscale:=strtoint(Video_Info[IDV_Scale]);
      except
         vrate:=0;
         vscale:=0;
      end;
      /// recalculate duration
      if vrate>0 then video_info[IDV_Duration]:=
         inttostr(round(vscale/vrate*dmlh.dwTotalFrames*1000));
   end;
procedure Process_idvx; // parse IDVX chunk (IDivX tags)
   type
      TIDivXTags=record
         Movie:array [1..32] of char;
         Author:array [1..28] of char;
         Year:array [1..4] of char;
         Comment:array [1..48] of char;
         Genre:array [1..3] of char;
         Rating:byte;
         Blank:array [1..5] of byte;
         Signature:array [1..7] of char;
      end;
   var
      IDivXTags:TIDivXTags;
      cur_size:longword;
      sum_size:longword;
      temp:string;
   function x2str(x:array of char):string;
   var z:integer;
       temp:string;
   begin
      temp:='';
      for z:=low(x) to high(x) do begin
         if x[z]<>#0 then temp:=temp+x[z] else break;
      end;
      result:=temp;
   end;
   begin
      if length(buffer)-1>=sizeof(IDivXTags)
         then Move(buffer[1],IDivXTags,sizeof(IDivXTags))
         else exit;
      if IDivXTags.signature<>'DIVXTAG' then exit;
      if Build_Tree then begin
         sum_size:=0; cur_size:=sizeof(IDivXTags.Movie); temp:=x2str(IDivXTags.Movie);
         add_info(sum_size,list_deep+1,'IDivX.Movie',temp,cur_size,x_str);
         inc(sum_size,cur_size); cur_size:=sizeof(IDivXTags.Author); temp:=x2str(IDivXTags.Author);
         add_info(sum_size,list_deep+1,'IDivX.Author',temp,cur_size,x_str);
         inc(sum_size,cur_size); cur_size:=sizeof(IDivXTags.Year); temp:=x2str(IDivXTags.Year);
         add_info(sum_size,list_deep+1,'IDivX.Year',temp,cur_size,x_str);
         inc(sum_size,cur_size); cur_size:=sizeof(IDivXTags.Comment); temp:=x2str(IDivXTags.Comment);
         add_info(sum_size,list_deep+1,'IDivX.Comment',temp,cur_size,x_str);
         inc(sum_size,cur_size); cur_size:=sizeof(IDivXTags.Genre); temp:=x2str(IDivXTags.Genre);
         add_info(sum_size,list_deep+1,'IDivX.Genre',temp,cur_size,x_str);
         inc(sum_size,cur_size); cur_size:=sizeof(IDivXTags.Rating);
         add_info(sum_size,list_deep+1,'IDivX.Rating',IDivXTags.Rating,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(IDivXTags.Blank);
         add_info(sum_size,list_deep+1,'IDivX.Blank',null,cur_size,x_null);
         inc(sum_size,cur_size); cur_size:=sizeof(IDivXTags.signature); temp:=x2str(IDivXTags.signature);
         add_info(sum_size,list_deep+1,'IDivX.Signature',temp,cur_size,x_str);
      end;
      Other_tags[IDO_IDivX_Title]:=IDivXTags.Movie;
      Other_tags[IDO_IDivX_Author]:=IDivXTags.Author;
      Other_tags[IDO_IDivX_Genre]:=IDivXTags.Genre;
      Other_tags[IDO_IDivX_Year]:=IDivXTags.Year;
      Other_tags[IDO_IDivX_Comments]:=IDivXTags.Comment;
      Other_tags[IDO_IDivX_Rating]:=inttostr(IDivXTags.Rating);
   end;
procedure Process_idx1; // parse idx1 chunk
   type
      Tidx1=record
         fccChunkID:TFourCC;     // XXwb - audio, XXdc,XXdb - video
         dwFlags:Longword;       // $10 - keyframe
         dwChunkOffset:Longword; // offset from "movi" chunk beginning
         dwChunkLength:Longword; // bytes
      end;
   const
      idx1_flags:array [1..1] of TFlagInfo=(
         (flag:$0010;name:'KEY_FRAME')
      );
   var
      idx1:Tidx1;
      sum_size:longword;
      vsize,asize1,asize2,asize3:int64;
      keyframes, frames, max_frame_size: longword;
      dwEntriesInUse:longword;
      x:longword;
      vrate,vscale:longword;
   begin
      dwEntriesInUse:=longword(length(buffer)-1) div sizeof(idx1);
      if dwEntriesInUse=0 then exit; 
      if Build_Tree then begin
         sum_size:=0;
         if longword(length(buffer)-1) = dwEntriesInUse*16 then begin // scan all entries
            for x:=0 to dwEntriesInUse-1 do begin
               Move(buffer[sum_size+1],idx1,16);
               add_info(sum_size,list_deep+1,'IndexEntry',null,16,x_null);
               add_info(sum_size,list_deep+2,'fccChunkID',idx1.fccChunkID,4,x_fcc);
               inc(sum_size,4);
               add_info(sum_size,list_deep+2,'dwFlags',idx1.dwFlags,4,x_hex_dw);
               add_flags(sum_size,list_deep+3,idx1.dwFlags,idx1_flags,sizeof(idx1.dwFlags));
               inc(sum_size,4);
               add_info(sum_size,list_deep+2,'dwChunkOffset',idx1.dwChunkOffset,4,x_dec);
               inc(sum_size,4);
               add_info(sum_size,list_deep+2,'dwChunkLength',idx1.dwChunkLength,4,x_dec);
               inc(sum_size,4);
               if (x>=longword(Max_Entries)) and (Max_Entries>0) then begin
                  add_info(sum_size,list_deep+1,'Skipped_IndexEntries',null,((dwEntriesInUse-1)-x)*16,x_null);
                  break;
               end;
            end;
         end;
      end;
      if Parsed_Super_Index then exit; // skip idx1 information if super index was parsed already
      sum_size:=0;
      if longword(length(buffer)-1) = dwEntriesInUse*16 then begin // scan all entries
         frames:=0; keyframes:=0; max_frame_size:=0;
         vsize:=0; asize1:=0; asize2:=0; asize3:=0;
         for x:=0 to dwEntriesInUse-1 do begin
            Move(buffer[sum_size+1],idx1,16);
            inc(sum_size,16);
            if (idx1.fccChunkID='00dc') or (idx1.fccChunkID='00db') then begin // video stream
               inc(frames);
               if idx1.dwFlags=$10 then inc(keyframes);; // key frame
               inc(vsize,idx1.dwChunkLength);
               if idx1.dwChunkLength>max_frame_size then max_frame_size:=idx1.dwChunkLength;
            end;
            if (idx1.fccChunkID='01wb') then begin // audio stream 1
               inc(asize1,idx1.dwChunkLength);
            end;
            if (idx1.fccChunkID='02wb') then begin // audio stream 2
               inc(asize2,idx1.dwChunkLength);
            end;
            if (idx1.fccChunkID='03wb') then begin // audio stream 3
               inc(asize3,idx1.dwChunkLength);
            end;
         end;
         video_info[IDV_Frames]:=inttostr(frames);
         video_info[IDV_Key_Frames]:=inttostr(keyframes);
         video_info[IDV_Size]:=inttostr(vsize);
         audio1_info[IDA_Size]:=inttostr(asize1);
         audio2_info[IDA_Size]:=inttostr(asize2);
         audio3_info[IDA_Size]:=inttostr(asize3);
         try
            vrate:=strtoint(Video_Info[IDV_Rate]);
            vscale:=strtoint(Video_Info[IDV_Scale]);
         except
            vrate:=0;
            vscale:=0;
         end;
         if vscale*vrate>0 then begin
            video_info[IDV_Maximum_Data_Rate]:=inttostr(round(max_frame_size/vscale*vrate*8));
            video_info[IDV_Duration]:=inttostr(round(vscale/vrate*frames*1000));
         end;
       end;
   end;
procedure calculate_characteristics;
   type
      TRatioInfo=record
         ratio:real;
         format:string;
      end;
   const
      predef_ratio: array [1..16] of TRatioInfo =(
         (ratio:0.95;format:'1 x 1'),
         (ratio:1.1;format:'5 x 6'),
         (ratio:1.265;format:'3 x 4'),
         (ratio:1.345;format:'11 x 15'),
         (ratio:1.365;format:'19 x 26'),
         (ratio:1.405;format:'9 x 13'),
         (ratio:1.47;format:'2 x 3'),
         (ratio:1.58;format:'3 x 5'),
         (ratio:1.705;format:'4 x 7'),
         (ratio:1.765;format:'9 x 16'),
         (ratio:1.815;format:'13 x 24'),
         (ratio:1.905;format:'23 x 45'),
         (ratio:1.98;format:'1 x 2'),
         (ratio:2.1;format:'5 x 11'),
         (ratio:2.275;format:'17 x 40'),
         (ratio:2.45;format:'11 x 28')
      );
   var
      temp:string;
      x:longword;

      height,            // pixel
      width,             // pixel
      vrate,             // frame
      vscale,            // second
      arate1,            // sample
      ascale1,           // second
      arate2,            // sample
      ascale2,           // second
      arate3,            // sample
      ascale3,           // second
      asamplesize1,      // bytes
      asamplesize2,      // bytes
      asamplesize3,      // bytes
      alength1,          // samples
      alength2,          // samples
      alength3,          // samples
      vlength,           // frame
      vduration,         // milisecond
      aduration1,        // milisecond
      aduration2,        // milisecond
      aduration3:int64;  // milisecond
      asize1,            // byte
      asize2,            // byte
      asize3,            // byte
      vsize:int64;       // byte

      vbitrate,          // bits per second
      abitrate:longword; // bits per second
      ratio,             // dimensionless
      framerate,         // frames per second
      effbpp:real;       // effective bits per pixel
      bpp:integer;       // color depth bits per pixel
   begin
      try
         vlength:=strtoint(video_info[IDV_Frames]);
         vduration:=strtoint(Video_Info[IDV_Duration]);
      except
         vlength:=0;
         vduration:=0;
      end;
      try
         vrate:=strtoint(Video_Info[IDV_Rate]);
         vscale:=strtoint(Video_Info[IDV_Scale]);
      except
         vrate:=0;
         vscale:=0;
      end;
      try
         height:=strtoint(Video_Info[IDV_Height]);
         width:=strtoint(Video_Info[IDV_Width]);
      except
         height:=0;
         width:=0;
      end;
      if height>0 then ratio:=width/height else ratio:=0;
      temp:=''; // low limit
      for x:=low(predef_ratio) to high(predef_ratio) do
         if (ratio>predef_ratio[x].ratio) then temp:=predef_ratio[x].format;
      if ratio>2.60 then temp:=''; // high limit
      Video_Info[IDV_Aspect_Ratio]:=format('%.2f',[ratio]);
      Video_Info[IDV_Frame_Proportion]:=temp;
      // calculate sizes of streams
      try
         asize1:=strtoint64(audio1_info[IDA_Size])*8; // bits
      except
         asize1:=0;
      end;
      try
         asamplesize1:=strtoint64(audio1_info[IDA_Sample_Size]);
      except
         asamplesize1:=0;
      end;
      try
         arate1:=strtoint(Audio1_Info[IDA_Rate]);
         ascale1:=strtoint(Audio1_Info[IDA_Scale]);
      except
         arate1:=0;
         ascale1:=0;
      end;
      if asamplesize1*asize1>0 then Audio1_Info[IDA_Length] := inttostr(round( (asize1/8) / asamplesize1)); // try to calculate the real count of sample
      try
         alength1:=strtoint64(Audio1_Info[IDA_Length]);
      except
         alength1:=0;
      end;
      if ascale1*arate1>0 then Audio1_Info[IDA_Duration]:=inttostr(round((ascale1/arate1)*alength1*1000)); // try to calculate duration in milliseconds
      try
         aduration1:=strtoint(Audio1_Info[IDA_Duration]);
      except
         aduration1:=0;
      end;
      if asize1=0 then begin // try to get it from header data
         try
            abitrate:=strtoint(Audio1_Info[IDA_Data_Rate]);
         except
            abitrate:=0;
         end;
         asize1:=round(abitrate*aduration1/1000);
         audio1_info[IDA_Size]:=inttostr(round(asize1/8)); // bytes
      end;

      try
         asize2:=strtoint64(audio2_info[IDA_Size])*8; // bits
      except
         asize2:=0;
      end;
      try
         asamplesize2:=strtoint64(audio2_info[IDA_Sample_Size]);
      except
         asamplesize2:=0;
      end;
      try
         arate2:=strtoint(Audio2_Info[IDA_Rate]);
         ascale2:=strtoint(Audio2_Info[IDA_Scale]);
      except
         arate2:=0;
         ascale2:=0;
      end;
      if asamplesize2*asize2>0 then Audio2_Info[IDA_Length] := inttostr(round( (asize2/8) / asamplesize2)); // try to calculate the real count of sample
      try
         alength2:=strtoint64(Audio2_Info[IDA_Length]);
      except
         alength2:=0;
      end;
      if ascale2*arate2>0 then Audio2_Info[IDA_Duration]:=inttostr(round((ascale2/arate2)*alength2*1000)); // try to calculate duration in milliseconds
      try
         aduration2:=strtoint(Audio2_Info[IDA_Duration]);
      except
         aduration2:=0;
      end;
      if asize2=0 then begin // try to get it from header data
         try
            abitrate:=strtoint(Audio2_Info[IDA_Data_Rate]);
         except
            abitrate:=0;
         end;
         asize2:=round(abitrate*aduration2/1000);
         audio2_info[IDA_Size]:=inttostr(round(asize2/8)); // bytes
      end;

      try
         asize3:=strtoint64(audio3_info[IDA_Size])*8; // bits
      except
         asize3:=0;
      end;
      try
         asamplesize3:=strtoint64(audio3_info[IDA_Sample_Size]);
      except
         asamplesize3:=0;
      end;
      try
         arate3:=strtoint(Audio3_Info[IDA_Rate]);
         ascale3:=strtoint(Audio3_Info[IDA_Scale]);
      except
         arate3:=0;
         ascale3:=0;
      end;
      if asamplesize3*asize3>0 then Audio3_Info[IDA_Length] := inttostr(round( (asize3/8) / asamplesize3)); // try to calculate the real count of sample
      try
         alength3:=strtoint64(Audio3_Info[IDA_Length]);
      except
         alength3:=0;
      end;
      if ascale3*arate3>0 then Audio3_Info[IDA_Duration]:=inttostr(round((ascale3/arate3)*alength3*1000)); // try to calculate duration in milliseconds
      try
         aduration3:=strtoint(Audio3_Info[IDA_Duration]);
      except
         aduration3:=0;
      end;
      if asize3=0 then begin // try to get it from header data
         try
            abitrate:=strtoint(Audio3_Info[IDA_Data_Rate]);
         except
            abitrate:=0;
         end;
         asize3:=round(abitrate*aduration3/1000);
         audio3_info[IDA_Size]:=inttostr(round(asize3/8)); // bytes
      end;
      try
         vsize:=strtoint64(video_info[IDV_Size])*8;
      except
         vsize:=0;
      end;
      if vsize=0 then begin // try to get it from header data
         vsize:=Movi_Size*8 - asize1 - asize2 - asize3 - (audio_stream_counter+1)*8*vlength*8;
         if vsize<0 then vsize:=0;
         video_info[IDV_Size]:=inttostr(round(vsize/8)); // bytes
      end;
      // calculate bitrates
      if vduration>0 then vbitrate:=round(vsize/vduration*1000) else vbitrate:=0; // bits per second
      Video_Info[IDV_Data_Rate]:=inttostr(vbitrate);
      if aduration1>0 then abitrate:=round(asize1/aduration1*1000) else abitrate:=0; // bits per second
      Audio1_Info[IDA_Data_Rate]:=inttostr(abitrate);
      if aduration2>0 then abitrate:=round(asize2/aduration2*1000) else abitrate:=0; // bits per second
      Audio2_Info[IDA_Data_Rate]:=inttostr(abitrate);
      if aduration3>0 then abitrate:=round(asize3/aduration3*1000) else abitrate:=0; // bits per second
      Audio3_Info[IDA_Data_Rate]:=inttostr(abitrate);
      // calculate other characteristics
      if vscale>0 then framerate:=vrate/vscale else framerate:=0;
      if width*height*framerate>0 then effbpp:=vbitrate/(width*height*framerate) else effbpp:=0;
      if effbpp>0
         then Video_Info[IDV_Effective_Bits_Per_Pixel]:=format('%.3f',[effbpp])
         else Video_Info[IDV_Effective_Bits_Per_Pixel]:='0';
      try
         bpp:=strtoint(Video_Info[IDV_Bit_Depth]);
      except
         bpp:=0;
      end;
      if bpp*effbpp>0 then begin
         Video_Info[IDV_Compression]:=format('%.3f',[(1-(effbpp/bpp))*100]);
         Video_Info[IDV_Power_Of_Compression]:=format('%.1f : 1',[bpp/effbpp]);
      end else begin
         Video_Info[IDV_Compression]:='0';
         Video_Info[IDV_Power_Of_Compression]:='? : 1';
      end;
      if height*framerate>0
         then Video_Info[IDV_Effective_Bits_Per_Frame_3x4]:=inttostr(round((3*width*vbitrate)/(4*height*framerate)))
         else Video_Info[IDV_Effective_Bits_Per_Frame_3x4]:='0';
   end;
procedure Process_indx; // parse indx chunk
   type
      Tindx=record
         wLongsPerEntry:Word;     // size of each entry in aIndex array
         bIndexSubType:byte;      // depends on bIndexType
         bIndexType:byte;         // one of AVI_INDEX_* codes
         dwEntriesInUse:Longword; // index of first unused member in aIndex array
         fccChunkId:TFourCC;      // fcc of what is indexed
      end;
      Tindx_superindex=record   // AVI_INDEX_OF_INDEXES
         base:Tindx;            // 12 bytes
         dwReserved1:longword;
         dwReserved2:longword;
         dwReserved3:longword;
      end;
      Tsuperindex_entry=record // AVI_INDEX_OF_INDEXES
         qwOffset:int64;       // absolute file offset, offset 0 is unused entry ??
         dwSize:longword;      // size of index chunk at this offset
         dwDuration:longword;  // time span in stream ticks
      end;
      Tindx_frames=record      // AVI_INDEX_OF_CHUNKS
         base:Tindx;           // 12 bytes
         qwBaseOffset:int64;   // all dwOffsets in aIndex array are relative to this
         dwReserved3:longword; // must be 0
      end;
      Tframeindx_entry=record   // AVI_INDEX_OF_CHUNKS
         dwOffset:longword;     // qwBaseOffset + this is absolute file offset
         dwSize:longword;       // bit 31 is set if this is NOT a keyframe
      end;
      Tfieldindx_entry=record     // AVI_INDEX_2FIELD
         dwOffset:longword;       // qwBaseOffset + this is absolute file offset
         dwSize:longword;         // bit 31 is set if this is NOT a keyframe
         dwOffsetField2:longword; // offset to second field
      end;
   const
      AVI_INDEX_OF_INDEXES = $00; // when each entry in aIndex array points to an index chunk
      indxtype_flags:array [1..2] of TFlagInfo=(
         (flag:$01;name:'AVI_INDEX_OF_CHUNKS'),  // when each entry in aIndex array points to a chunk in the file
         (flag:$80;name:'AVI_INDEX_IS_DATA')    // when each entry is aIndex is really the data
      );
      indxsubtype_flags:array [1..1] of TFlagInfo=(
         (flag:$01;name:'AVI_INDEX_2FIELD')     // when fields within frames are also indexed
      );
   var
      real_size:longword;
      cur_size:longword;
      sum_size:longword;
      indx:Tindx;
      x:longword;
      indx_superindex:Tindx_superindex;
      superindx_entry:Tsuperindex_entry;
      indx_frames:Tindx_frames;
      frameindx_entry:Tframeindx_entry;
      fieldindx_entry:Tfieldindx_entry;
      key_frame:boolean;
      position:int64;
      buf:string;
   procedure parse_sub_index;
      var
         x:longword;
         indx_frames:Tindx_frames;
         frameindx_entry:Tframeindx_entry;
         fieldindx_entry:Tfieldindx_entry;
         real_size:longword;
         sum_size:int64;
         temp64:int64;
         keyframes, max_frame_size, frame_size: longword;
         temp: longword;
         vrate, vscale: longword;
      begin
         if length(buf)-1>=sizeof(indx_frames)
            then real_size:=sizeof(indx_frames)
            else real_size:=length(buf)-1;
         Move(buf[1],indx_frames,real_size);
         // summarize sizes of all data blocks and count keyframes
         sum_size:=0; keyframes:=0; max_frame_size:=0;
         if (indx_frames.base.bIndexSubType=0) and (longword(length(buf)-1) >= (real_size+8*indx_frames.base.dwEntriesInUse)) then begin // scan all entries
            for x:=1 to indx_frames.base.dwEntriesInUse do begin
               Move(buf[real_size+1],frameindx_entry,8);
               inc(real_size,8); // increase read counter
               if (frameindx_entry.dwSize and $80000000) = 0 then inc(keyframes);
               frame_size:=frameindx_entry.dwSize and $7FFFFFFF;
               inc(sum_size,frame_size); // add size of current data block
               if frame_size>max_frame_size then max_frame_size:=frame_size;
            end;
         end;
         if (indx_frames.base.bIndexSubType=1) and (longword(length(buf)-1) >= (real_size+12*indx_frames.base.dwEntriesInUse)) then begin // scan all entries
            for x:=1 to indx_frames.base.dwEntriesInUse do begin
               Move(buf[real_size+1],fieldindx_entry,12);
               inc(real_size,12);
               if (frameindx_entry.dwSize and $80000000) = 0 then inc(keyframes);
               frame_size:=frameindx_entry.dwSize and $7FFFFFFF;
               inc(sum_size,frame_size); // add size of current data block
               if frame_size>max_frame_size then max_frame_size:=frame_size;
            end;
         end;
         // save values for corresponding stream
         if (indx_frames.base.fccChunkId='00dc') or (indx_frames.base.fccChunkId='00db') then begin
            try
               temp:=strtoint(video_info[IDV_Key_Frames]);
            except
               temp:=0;
            end;
            video_info[IDV_Key_Frames]:=inttostr(temp+keyframes);
            try
               temp64:=StrToInt64(video_info[IDV_Size]);
            except
               temp64:=0;
            end;
            video_info[IDV_Size]:=inttostr(temp64+sum_size);
            try
               vrate:=strtoint(Video_Info[IDV_Rate]);
               vscale:=strtoint(Video_Info[IDV_Scale]);
            except
               vrate:=0;
               vscale:=0;
            end;
            try
               temp64:=strtoint64(video_info[IDV_Maximum_Data_Rate]);
            except
               temp64:=0;
            end;
            if (vscale>0) then begin
               if round(max_frame_size/vscale*vrate*8)>temp64 then
                  video_info[IDV_Maximum_Data_Rate]:=inttostr(round(max_frame_size/vscale*vrate*8));
            end;
         end;
         if (indx_frames.base.fccChunkId='01wb') then begin
            try
               temp64:=strtoint64(audio1_info[IDA_Size]);
            except
               temp64:=0;
            end;
            audio1_info[IDA_Size]:=inttostr(temp64+sum_size);
         end;
         if (indx_frames.base.fccChunkId='02wb') then begin
            try
               temp64:=strtoint64(audio2_info[IDA_Size]);
            except
               temp64:=0;
            end;
            audio2_info[IDA_Size]:=inttostr(temp64+sum_size);
         end;
         if (indx_frames.base.fccChunkId='03wb') then begin
            try
               temp64:=strtoint64(audio3_info[IDA_Size]);
            except
               temp64:=0;
            end;
            audio3_info[IDA_Size]:=inttostr(temp64+sum_size);
         end;
      end;
   begin
      if length(buffer)-1>=sizeof(indx)
         then real_size:=sizeof(indx)
         else real_size:=length(buffer)-1;
      Move(buffer[1],indx,real_size);
      if Build_Tree then begin
         sum_size:=0; cur_size:=sizeof(indx.wLongsPerEntry);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'wLongsPerEntry',indx.wLongsPerEntry,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(indx.bIndexSubType);
         if real_size>=sum_size+cur_size then begin
            add_info(sum_size,list_deep+1,'bIndexSubType',indx.bIndexSubType,cur_size,x_hex_b);
            add_flags(sum_size,list_deep+2,indx.bIndexSubType,indxsubtype_flags,cur_size);
         end;
         inc(sum_size,cur_size); cur_size:=sizeof(indx.bIndexType);
         if real_size>=sum_size+cur_size then begin
            add_info(sum_size,list_deep+1,'bIndexType',indx.bIndexType,cur_size,x_hex_b);
            if byte(indx.bIndexType)=AVI_INDEX_OF_INDEXES then add_info(sum_size,list_deep+2,'AVI_INDEX_OF_INDEXES',indx.bIndexType,0,x_hex_b);
            add_flags(sum_size,list_deep+2,indx.bIndexType,indxtype_flags,cur_size);
         end;
         inc(sum_size,cur_size); cur_size:=sizeof(indx.dwEntriesInUse);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwEntriesInUse',indx.dwEntriesInUse,cur_size,x_dec);
         inc(sum_size,cur_size); cur_size:=sizeof(indx.fccChunkId);
         if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'fccChunkId',indx.fccChunkId,cur_size,x_fcc);
         if indx.bIndexType=0 then begin // AVI_INDEX_OF_INDEXES
            if length(buffer)-1>=sizeof(indx_superindex)
               then real_size:=sizeof(indx_superindex)
               else real_size:=length(buffer)-1;
            Move(buffer[1],indx_superindex,real_size);
            sum_size:=sizeof(indx_superindex.base); cur_size:=sizeof(indx_superindex.dwReserved1);
            if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwReserved1',indx_superindex.dwReserved1,cur_size,x_hex_dw);
            inc(sum_size,cur_size); cur_size:=sizeof(indx_superindex.dwReserved2);
            if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwReserved2',indx_superindex.dwReserved2,cur_size,x_hex_dw);
            inc(sum_size,cur_size); cur_size:=sizeof(indx_superindex.dwReserved3);
            if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwReserved3',indx_superindex.dwReserved3,cur_size,x_hex_dw);
            inc(sum_size,cur_size);
            if longword(length(buffer)-1) >= (real_size+16*indx.dwEntriesInUse) then begin // scan all entries
               for x:=0 to indx.dwEntriesInUse-1 do begin
                  Move(buffer[real_size+1],superindx_entry,16);
                  add_info(sum_size,list_deep+1,'SuperIndexEntry',null,16,x_null);
                  add_info(sum_size,list_deep+2,'qwOffset',superindx_entry.qwOffset,8,x_dec_64);
                  inc(sum_size,8);
                  add_info(sum_size,list_deep+2,'dwSize',superindx_entry.dwSize,4,x_dec);
                  inc(sum_size,4);
                  add_info(sum_size,list_deep+2,'dwDuration',superindx_entry.dwDuration,4,x_dec);
                  inc(sum_size,4);
                  inc(real_size,16);
                  if (x>=longword(Max_Entries)) and (Max_Entries>0) then begin
                     add_info(sum_size,list_deep+1,'Skipped_SuperIndexEntries',null,((indx.dwEntriesInUse-1)-x)*16,x_null);
                     real_size:=sum_size+((indx.dwEntriesInUse-1)-x)*16;
                     break;
                  end;
               end;
            end;
         end;
         if indx.bIndexType=1 then begin // AVI_INDEX_OF_CHUNKS
            if length(buffer)-1>=sizeof(indx_frames)
               then real_size:=sizeof(indx_frames)
               else real_size:=length(buffer)-1;
            Move(buffer[1],indx_frames,real_size);
            sum_size:=sizeof(indx_frames.base); cur_size:=sizeof(indx_frames.qwBaseOffset);
            if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'qwBaseOffset',indx_frames.qwBaseOffset,cur_size,x_dec_64);
            inc(sum_size,cur_size); cur_size:=sizeof(indx_frames.dwReserved3);
            if real_size>=sum_size+cur_size then add_info(sum_size,list_deep+1,'dwReserved3',indx_frames.dwReserved3,cur_size,x_hex_dw);
            inc(sum_size,cur_size);
            if (indx.bIndexSubType=0) and (longword(length(buffer)-1) >= (real_size+8*indx.dwEntriesInUse)) then begin // scan all entries
               for x:=1 to indx.dwEntriesInUse do begin
                  Move(buffer[real_size+1],frameindx_entry,8);
                  add_info(sum_size,list_deep+1,'FrameIndexEntry',null,8,x_null);
                  add_info(sum_size,list_deep+2,'dwOffset',frameindx_entry.dwOffset,4,x_dec);
                  inc(sum_size,4);
                  key_frame:=(frameindx_entry.dwSize and $80000000) = 0;
                  frameindx_entry.dwSize:=frameindx_entry.dwSize and $7FFFFFFF;
                  add_info(sum_size,list_deep+2,'dwSize',frameindx_entry.dwSize,4,x_dec);
                  if key_frame then add_info(sum_size,list_deep+3,'KEY_FRAME',null,0,x_null);
                  inc(sum_size,4);
                  inc(real_size,8);
                  if (x>=longword(Max_Entries)) and (Max_Entries>0) then begin
                     add_info(sum_size,list_deep+1,'Skipped_FrameIndexEntries',null,((indx.dwEntriesInUse-1)-x)*8,x_null);
                     real_size:=sum_size+((indx.dwEntriesInUse-1)-x)*8;
                     break;
                  end;
               end;
            end;
            if (indx.bIndexSubType=1) and (longword(length(buffer)-1) >= (real_size+12*indx.dwEntriesInUse)) then begin // scan all entries
               for x:=1 to indx.dwEntriesInUse do begin
                  Move(buffer[real_size+1],fieldindx_entry,12);
                  add_info(sum_size,list_deep+1,'FieldIndexEntry',null,12,x_null);
                  add_info(sum_size,list_deep+2,'dwOffset',fieldindx_entry.dwOffset,4,x_dec);
                  inc(sum_size,4);
                  key_frame:=(fieldindx_entry.dwSize and $80000000) = 0;
                  fieldindx_entry.dwSize:=fieldindx_entry.dwSize and $7FFFFFFF;
                  add_info(sum_size,list_deep+2,'dwSize',fieldindx_entry.dwSize,4,x_dec);
                  if key_frame then add_info(sum_size,list_deep+3,'KEY_FRAME',null,0,x_null);
                  inc(sum_size,4);
                  add_info(sum_size,list_deep+2,'dwOffsetField2',fieldindx_entry.dwOffsetField2,4,x_dec);
                  inc(sum_size,4);
                  inc(real_size,12);
                  if (x>=longword(Max_Entries)) and (Max_Entries>0) then begin
                     add_info(sum_size,list_deep+1,'Skipped_FieldIndexEntries',null,((indx.dwEntriesInUse-1)-x)*12,x_null);
                     real_size:=sum_size+((indx.dwEntriesInUse-1)-x)*12;
                     break;
                  end;
               end;
            end;
         end;
         if longword(length(buffer))-1 >= real_size then
            add_info(real_size,list_deep+1,'SuperIndex_JUNK',null,longword(length(buffer))-1-real_size,x_null);
      end;
      if list_name='movi' then exit; // all indexes in movi section are addressed from header
      Parsed_Super_Index:=true; // don't parse idx1 chunk if ODML index was parsed
      position:=in_big_file.FilePos; // remember position in file
      case indx.bIndexType of
         $00:begin // AVI_INDEX_OF_INDEXES
            if length(buffer)-1>=sizeof(indx_superindex)
               then real_size:=sizeof(indx_superindex)
               else real_size:=length(buffer)-1;
            Move(buffer[1],indx_superindex,real_size);
            if longword(length(buffer)-1) >= (real_size+16*indx.dwEntriesInUse) then begin // scan all entries
               for x:=0 to indx.dwEntriesInUse-1 do begin
                  Move(buffer[real_size+1],superindx_entry,16);
                  inc(real_size,16);
                  // ignore seek/read errors - they should be detected in main procedure of linear parsing
                  try SetLength(buf,superindx_entry.dwSize-8+1); except end; // allocate enougth memory
                  try in_big_file.Seek(superindx_entry.qwOffset+8); except end;// go to position of subindex
                  try in_big_file.BlockRead(buf[1],superindx_entry.dwSize-8,res); except end;// read subindex
                  parse_sub_index;
               end;
            end;
         end;
         $01:begin // AVI_INDEX_OF_CHUNKS
            if length(buffer)-1>=sizeof(indx_frames)
               then real_size:=sizeof(indx_frames)
               else real_size:=length(buffer)-1;
            Move(buffer[1],indx_frames,real_size);
            try SetLength(buf,length(buffer)); except end; // allocate enougth memory
            Move(buffer[1],buf[1],length(buffer)-1);
            parse_sub_index;
         end;
      end;
      in_big_file.Seek(position); // back to the remembered position
   end;
procedure Process_junk; // parse JUNK chunk
   begin
   end;
procedure Process_Premier; // parse Premier tag
   begin
   end;
begin
      // initialization
      Ignore_Errors:=(Parse_Mode and PM_Ignore_Errors) > 0;
      Build_Tree:=(Parse_Mode and PM_Build_Tree) > 0;
      Parse_Index:=(Parse_Mode and PM_Parse_Index) > 0;
      Parse_JUNK:=(Parse_Mode and PM_Parse_JUNK) > 0;
      Parse_movi:=(Parse_Mode and PM_Parse_movi) > 0;
      Tech_Info:=(Parse_Mode and PM_Tech_Info) > 0;
      Read_IDivX:=(Parse_Mode and PM_Read_IDivX) > 0;
      Read_MovieID:=(Parse_Mode and PM_Read_MovieID) > 0;
      Parse_Premier:=(Parse_Mode and PM_Parse_Premier) >0;
      AVI_Info:=OleVariant(VarArrayCreate([0,IDI_max,0,AVI_Info_max],varVariant)); // allocate memory for AVI information
      for x:=0 to IDT_max do AVI_Info[IDI_INFO_Tags,x]:=''; // initialize tag's values
      if (Parse_JUNK or Read_IDivX or Read_MovieID or Parse_Premier) then
         for x:=0 to IDO_max do AVI_Info[IDI_Other_Tags,x]:=''; // initialize other tag's values (JUNK, IDivX, etc)
      if Tech_Info then for x:=0 to IDV_max do AVI_Info[IDI_Video_Stream,x]:=''; // initialize tag's values
      if Tech_Info then for x:=0 to IDA_max do AVI_Info[IDI_Audio_Stream,x]:=''; // initialize tag's values
      if Tech_Info then for x:=0 to IDA_max do AVI_Info[IDI_Audio_Stream2,x]:=''; // initialize tag's values
      if Tech_Info then for x:=0 to IDA_max do AVI_Info[IDI_Audio_Stream3,x]:=''; // initialize tag's values
      if Build_Tree then AVI_Info[IDI_Structure_Tree,0]:=''; // init tree of structure
      // init internal variables
      ReadAviTags:=PE_Parse_Ok; // no errors occurred
      dv_video:=false; // no "iavs" stream found
      audio_stream_counter:=0; // no audio streams found
      video_stream_counter:=0; // no video streams found
      movi_counter:=0;
      movi_end:=0;
      movi_size:=0;
      Parsed_Super_Index:=false;
      // end of initialization
      Attributes :=  FileGetAttr(file_name); // get file attributes
      if (Attributes and faDirectory) = faDirectory then begin // if it's a directory - go out
         if log_error(PE_Open_Error) then exit;
      end;
      in_big_file:=TGpHugeFile.CreateEx(file_name,FILE_ATTRIBUTE_NORMAL,GENERIC_READ,FILE_SHARE_READ);
      try
         in_big_file.ResetBuffered(1,0,false); // block size 1 byte, default buffer 64kb, not locked
      except
         ReadAviTags:=PE_Open_Error; // if failed - set error code and go out
         exit;
      end;
      try
         in_big_file.BlockRead(riff_name,4,res);
         in_big_file.BlockRead(riff_length,4,res);
         in_big_file.BlockRead(list_name,4,res);
      except
         if log_error(PE_Read_Error) then exit; // if failed - set error code and go out
      end;
      if riff_name<>'RIFF' then begin // the name should be 'RIFF'
         if log_error(PE_Not_RIFF_Error) then exit; // if failed - set error code and go out
      end;
      avi_length:=riff_length+8; // compute correct RIFF length
      file_size:=in_big_file.FileSize;
      if avi_length>file_size then begin // the length of file should be not shorter then RIFF length
         if log_error(PE_Wrong_Size_Error) then exit; // if failed - set error code and go out
      end;
      if list_name<>'AVI ' then begin // AVI file should have the corresponding mark
         if log_error(PE_Not_AVI_Error) then exit; // if failed - set error code and go out
      end;
      // now we have normal AVI
      in_big_file.Seek(0); // go to the start of file
      temp_tree:=TStringList.Create;
      list_deep:=0; // zero level of enclosed lists
      while not (in_big_file.FilePos>=file_size) do begin // process all file till EOF
         last_pos:=in_big_file.FilePos; // remember the position of chunk beginning
         try
            in_big_file.BlockRead(riff_name,4,res);
            in_big_file.BlockRead(riff_length,4,res);
         except
            if log_error(PE_Read_Error) then exit; // if failed - set error code and go out
         end;
         inc_counters(8); // increase all the read counters
         if (riff_length>file_size-(last_pos+8)+1) or (riff_length=0) then begin
            //riff_length:=0; // legal minimum value
            if (list_deep<>0) or (riff_name='RIFF') then begin // set error only inside RIFF structure
               if log_error(PE_Wrong_Structure_Error) then exit; // if error - set error code and go out
            end;
            if (riff_name='RIFF') and (riff_length=0) then riff_length:=file_size-last_pos-8;
         end;
         if (riff_length mod 2 = 1) then inc(riff_length); // allign length to 2
         if (list_deep=0) and (riff_name<>'RIFF') and (riff_name<>'JUNK') and (riff_name<>'IDVX') then begin // skip info outside of RIFF chunks
            try
               in_big_file.Seek(in_big_file.FilePos+riff_length);
            except
               if log_error(PE_Seek_Error) then exit; // if error - set error code and go out
            end;
            inc_counters(riff_length); // increase all the read counters
         end else
         if (riff_name='LIST') or (riff_name='RIFF') then begin // LIST or RIFF chunk found
            try
               in_big_file.BlockRead(list_name,4,res);
            except
               if log_error(PE_Read_Error) then exit; // if error - set error code and go out
            end;
            if Build_Tree then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:s %4:d]: $(%3:s)',[int64(last_pos),deep2tab(list_deep),fcc2str(riff_name),fcc2str(list_name),riff_length]));
            inc(list_deep); // increase list deep
            with lists[list_deep] do begin // initialize new counter
               value:=riff_length;   // remember list length
               counter:=0;           // initialize counter of bytes read
            end;
            inc_counters(4); // increase all the read counters
            if (list_name='movi') then begin // skip LIST movi - usually the biggest list in AVI file (video/audio data)
               movi_size:=movi_size+riff_length;
               if (parse_movi) then begin
                  movi_end:=in_big_file.FilePos+riff_length-4;
                  movi_counter:=0;
               end else begin
                  try
                     in_big_file.Seek(in_big_file.FilePos+riff_length-4);
                  except
                     if log_error(PE_Seek_Error) then exit; // if error - set error code and go out
                  end;
                  inc_counters(riff_length-4); // increase all the read counters
               end;
            end;
         end else begin// other chunk except LIST and RIFF found
            if Build_Tree then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s)',[int64(last_pos),deep2tab(list_deep),fcc2str(riff_name),riff_length]));
            try
               SetLength(buffer,riff_length+1); // allocate enougth memory
            except
               if log_error(PE_Memory_Error) then exit; // if error - set error code and go out
            end;
            try
               in_big_file.BlockRead(buffer[1],riff_length,res); // read tag content
            except
               if log_error(PE_Read_Error) then exit; // if error - set error code and go out
            end;
            if riff_name='idx1' then begin
               if Tech_Info and Parse_index then Process_idx1
            end else
               if riff_name='avih' then begin
                  if Tech_Info then Process_avih
               end else
                  if riff_name='strh' then begin
                     if Tech_Info then Process_strh
                  end else
                     if riff_name='strf' then begin
                        if Tech_Info then Process_strf
                     end else
                        if riff_name='dmlh' then begin
                           if Tech_Info then Process_dmlh
                        end else
                           if riff_name='JUNK' then begin
                              if Parse_JUNK then Process_junk
                           end else
                              if riff_name=FourCC_zero then begin
                                 if Parse_Premier and (list_name='INFO') then Process_Premier
                              end else
                                 if riff_name='IDVX' then begin
                                    if Read_IDivX then Process_idvx
                                 end else
                                    if riff_name='indx' then begin
                                       if Tech_Info and Parse_index then Process_indx
                                    end else begin
                                       if list_name='INFO' then Recognize_tag;
                                       if Read_MovieID and (list_name='MID ') then Recognize_mid;
                                       if (list_name='movi') then begin
                                          if (parse_movi) and (riff_name[1]='i') and (riff_name[2]='x') and (riff_name[3] in ['0'..'9']) and (riff_name[4] in ['0'..'9']) then Process_indx;
                                       end;
                                    end;
            SetLength(buffer,0); // free memory
            inc_counters(riff_length); // increase all the read counters
            /// skip all
            if (parse_movi) and (list_name='movi') then begin
               inc(movi_counter);
               if (movi_counter>=longword(Max_Entries)) and (Max_Entries>0) then begin
                  list_name:='    ';
                  last_pos:=in_big_file.FilePos;
                  if Build_Tree then temp_tree.Add(format('%0:.12d: %1:s[%2:s %3:d]: $(%2:s)',[int64(last_pos),deep2tab(list_deep),'Skipped_movi_entries',movi_end-in_big_file.FilePos]));
                  inc_counters(movi_end-in_big_file.FilePos); // increase all the read counters
                  try
                     in_big_file.Seek(movi_end);
                  except
                     if log_error(PE_Seek_Error) then exit; // if error - set error code and go out
                  end;
               end;
            end;
         end;
         check_counters; // check the counters
      end;
      in_big_file.Free;
      if Tech_Info then calculate_characteristics;
      for x:=0 to IDT_max do AVI_Info[IDI_INFO_Tags,x]:=info_tags[x]; // assign tag's values
      if (Parse_JUNK or Read_IDivX or Read_MovieID or Parse_Premier) then
         for x:=0 to IDO_max do AVI_Info[IDI_Other_Tags,x]:=other_tags[x]; // assign other tag's values
      if Tech_Info then for x:=0 to IDV_max do AVI_Info[IDI_Video_Stream,x]:=Video_Info[x]; // assign video stream info
      if Tech_Info then for x:=0 to IDA_max do AVI_Info[IDI_Audio_Stream,x]:=Audio1_Info[x]; // assign audio stream 1 info
      if Tech_Info then for x:=0 to IDA_max do AVI_Info[IDI_Audio_Stream2,x]:=Audio2_Info[x]; // assign audio stream 2 info
      if Tech_Info then for x:=0 to IDA_max do AVI_Info[IDI_Audio_Stream3,x]:=Audio3_Info[x]; // assign audio stream 2 info
      if Build_Tree then AVI_Info[IDI_Structure_Tree,0]:=temp_tree.Text; // assign tree structure info
      temp_tree.Free;
end;

function TExtendedAVITags.WriteAVITags(File_Name,
  AVI_Info: OleVariant): HResult;
type tlist_info=record          // structure for remember enclosed RIFF lists
         address:longint;       // address in new header
         old_value:longint;     // old value (needed for reading info)
         read_counter:longint;  // read counter
         write_counter:longint; // new length of the list
     end;
     TRiff_Info=record
        name:TFourCC;
        length:longint;
     end;
var in_file:file; // target tag file
    tags:TINFO_tags;
    out_stream1,out_stream2:TmemoryStream; // buffers for creation of header and footer of the file
    tags_stream:TmemoryStream; // buffer for creation tags structure
    riff_info:TRiff_Info; // variable for reading RIFF elements
    list_deep:longint; // counter of current deep of enclosure
    lists:array[1..10]of tlist_info; // information about enclosed RIFF lists
    list_name:TFourCC;// name of current list
    buffer:array[1..131072]of char;// file read buffer
    tail_start:longint;// position of footer to write in file
    movi_start:longint;// end of header
    x,zero:longint;
    error:boolean;
procedure add_tags(tag:string; tag_FCC:TFourCC);
   var temp:string;
       x:integer;
   begin
      temp:=''; // delete additional zero at the end of string
      for x:=1 to length(tag) do if tag[x]<>#0 then temp:=temp+tag[x];
      tag:=temp;
      if tag<>'' then begin
         riff_info.name:=tag_FCC; riff_info.length:=length(tag)+1;
         tags_stream.Write(riff_info,8);
         tags_stream.Write(tag[1],riff_info.length);
         inc(lists[1].write_counter,riff_info.length+8); // increase write counters
         if (riff_info.length mod 2) = 1 then begin // allign by 2 bytes
            tags_stream.Write(zero,1);
            inc(lists[1].write_counter);
         end;
      end;
   end;
begin
      for x:=0 to IDT_max do tags[x]:=getinfo(AVI_Info,IDI_INFO_Tags,x); // assign tag's values
      FileMode:=fmOpenReadWrite or fmShareExclusive; // set the file open mode (for change)
      try
         {$I-}AssignFile(in_file,file_name); // try to assign
         reset(in_file,1);{$I+}              // and open file
      except
         result:=PE_Open_Error; // if failed - set error code
         exit; // and go out
      end;
      {$I-}blockread(in_file,riff_info,8);{$I+} // read RIFF header
      if IOResult<>0 then begin   // if failed - set error code and go out
         result:=PE_Read_Error;
         {$I-}close(in_file);{$I+}
         if IOResult<>0 then;
         exit;
      end;
      if riff_info.name<>'RIFF' then begin // if not RIFF file - set error code and go out
         result:=PE_Not_RIFF_Error;
         {$I-}close(in_file);{$I+}
         if IOResult<>0 then;
         exit;
      end;
      {$I-}blockread(in_file,riff_info,4);{$I+}
      if IOResult<>0 then begin  // if failed - set error code and go out
         result:=PE_Read_Error;
         {$I-}close(in_file);{$I+}
         if IOResult<>0 then;
         exit;
      end;
      if riff_info.name<>'AVI ' then begin
         result:=PE_Not_AVI_Error; // if failed - set error code and go out
         {$I-}close(in_file);{$I+}
         if IOResult<>0 then;
         exit;
      end;
      out_stream1:=TmemoryStream.Create; // create header buffer
      out_stream2:=TmemoryStream.Create; // create footer buffer
      tags_stream:=TmemoryStream.Create; // create tags buffer
      error:=false;
      movi_start:=0;
{??}  tail_start:=12; // initial start of footer (after "RIFF    AVI")
      Out_stream1.Write('RIFF    AVI ',12); // write standard AVI header
      //(at the position 4 the new length of AVI should be written)
      list_deep:=0; // zero level of enclosed lists
      while not eof(in_file) do begin // quit on end of file
         zero:=filepos(in_file); // remember current position
         {$I-}blockread(in_file,riff_info,8);{$I+}// read RIFF info
         if IOResult<>0 then error:=true;
         for x:=1 to list_deep do inc(lists[x].read_counter,8); // increase all the read counters
         if (riff_info.length mod 2 = 1) then inc(riff_info.length); // allign length to 2
         if riff_info.name='LIST' then begin // new LIST found
            {$I-}blockread(in_file,list_name,4);{$I+} // read list name
            if IOResult<>0 then error:=true;
            if list_name='movi' then movi_start:=zero;// set new start of audio/video section
            for x:=1 to list_deep do inc(lists[x].read_counter,4);// increase all the read counters
            if (list_name='movi') or (list_name='INFO')
            then begin // skip LIST movi - usual the biggest list in AVI file (video/audio data)
               {$I-}seek(in_file,filepos(in_file)+riff_info.length-4);{$I+}// skip section
               if IOResult<>0 then error:=true;
               for x:=1 to list_deep do inc(lists[x].read_counter,riff_info.length-4); // increase all the read counters
               if (list_name='movi') then begin
      {??}        tail_start:=filepos(in_file); // set new start of footer
                  break; // if found movi list - end read of header
               end;
            end;
            if not ((list_name='INFO') or (list_name='MID ')) then begin
               out_stream1.write(riff_info,8); // write RIFF structure to header buffer
               out_stream1.write(list_name,4); // write list name to heade buffer
               for x:=1 to list_deep do inc(lists[x].write_counter,12); // increase write counters
               inc(list_deep); // increase list deep
               with lists[list_deep] do begin // make new counter
                  old_value:=riff_info.length; // remember old length of list
                  read_counter:=4;             // initialize counter
                  write_counter:=4;            // initialize counter
                  address:=out_stream1.Size-8; // position of counter in the stream (buffer)
               end;
            end; // end of making new counter
         end; // end of processing new list
         if riff_info.name='JUNK' then begin // just for space section
            {$I-}seek(in_file,filepos(in_file)+riff_info.length);{$I+}// skip section
            if IOResult<>0 then error:=true;
            for x:=1 to list_deep do inc(lists[x].read_counter,riff_info.length); // increase all the read counters
         end; // end of JUNK processing
         if (riff_info.name<>'JUNK') and (riff_info.name<>'LIST') then begin
            if (riff_info.length<=filesize(in_file)-filepos(in_file)+1) and (riff_info.length>0)
            then begin // normal tag
               if (riff_info.length>131072)
            {$I-} then seek(in_file,filepos(in_file)+riff_info.length)// skip section
                  else blockread(in_file,buffer,riff_info.length);{$I+} // read tag content
               if IOResult<>0 then error:=true;
               for x:=1 to list_deep do inc(lists[x].read_counter,riff_info.length); // increase all the read counters
               if riff_info.name='idx1' then begin
{??}              tail_start:=filepos(in_file); // set new start of footer
                  break; // go out from read header loop
               end;
               if (riff_info.length<=131072) then begin // write tag to stream
                  out_stream1.write(riff_info,8);
                  out_stream1.write(buffer,riff_info.length);
                  for x:=1 to list_deep do inc(lists[x].write_counter,8+riff_info.length); // increase write counters
               end;
            end;
         end;// end of normal tag processing
         zero:=list_deep;
         for x:=1 to zero do // check the counters
             if lists[x].read_counter=lists[x].old_value then begin
                dec(list_deep); // decrease list deep
                out_stream1.Seek(lists[x].address,soFromBeginning); // go to counter position
                out_stream1.write(lists[x].write_counter,4); // write counter value
                out_stream1.Seek(0,soFromEnd); // go back to end of stream
             end;
      end;
      {here we have out_stream1 with the header of the file without JUNK sections
      and without INFO section. Now we should find end of idx1 list and read
      file footer (like header - without INFO sections and incorrect sections)}
      seek(in_file,tail_start);// go to footer beginning
      list_deep:=0; // zero list deep
      while not eof(in_file) do begin // end read on file end
         {$I-}blockread(in_file,riff_info,8);{$I+}// read RIFF info
         if IOResult<>0 then error:=true;
         for x:=1 to list_deep do inc(lists[x].read_counter,8); // increase all the read counters
         if (riff_info.length mod 2 = 1) then inc(riff_info.length); // allign length to 2
         if riff_info.name='LIST' then begin
            {$I-}blockread(in_file,list_name,4);{$I+} // read list name
            if IOResult<>0 then error:=true;
            if list_name='movi' then movi_start:=zero;// set new start of audio/video section

            for x:=1 to list_deep do inc(lists[x].read_counter,4);// increase all the read counters
            if (list_name='INFO') then begin // skip LIST movi - usual the biggest list in AVI file (video/audio data)
               {$I-}seek(in_file,filepos(in_file)+riff_info.length-4);{$I+}// skip section
               if IOResult<>0 then error:=true;
               for x:=1 to list_deep do inc(lists[x].read_counter,riff_info.length-4); // increase all the read counters
            end;
            if not (list_name='INFO') then begin
               out_stream2.write(riff_info,8); // write list header to stream
               out_stream2.write(list_name,4); // write list name to stream
               for x:=1 to list_deep do inc(lists[x].write_counter,12); // increase write counters
               inc(list_deep); // increase list deep
               with lists[list_deep] do begin // make new counter
                  old_value:=riff_info.length; // remember old length of list
                  read_counter:=4;             // initialize counter
                  write_counter:=4;            // initialize counter
                  address:=out_stream2.Size-8; // position of counter in the stream (buffer)
               end;
            end; // end of making new counter
         end; // end of processing new list
         if riff_info.name='JUNK' then begin // just for space section
            {$I-}seek(in_file,filepos(in_file)+riff_info.length);{$I+}// skip section
            if IOResult<>0 then error:=true;
            for x:=1 to list_deep do inc(lists[x].read_counter,riff_info.length); // increase all the read counters
         end; // end of JUNK processing
         if (riff_info.name<>'JUNK') and (riff_info.name<>'LIST') then begin
            if (riff_info.length<=filesize(in_file)-filepos(in_file)+1) and (riff_info.length>0)
            then begin // normal tag
               if (riff_info.length>131072)
            {$I-} then seek(in_file,filepos(in_file)+riff_info.length)// skip section
                  else blockread(in_file,buffer,riff_info.length);{$I+} // read tag content
               for x:=1 to list_deep do inc(lists[x].read_counter,riff_info.length); // increase all the read counters
               if IOResult<>0 then error:=true;
               if riff_info.name='idx1' then begin
{??}              tail_start:=filepos(in_file); // set new start of footer
                  list_deep:=0; //set zero level depth of enclosed lists
                  out_stream2.Clear; // clear buffer for footer
                  continue; // go to begin of WHILE loop
               end;
               if not (riff_info.length>131072) then begin // write tag to stream
                  out_stream2.write(riff_info,8);
                  out_stream2.write(buffer,riff_info.length);
                  for x:=1 to list_deep do inc(lists[x].write_counter,8+riff_info.length); // increase write counters
               end;
            end;
         end;// end of normal tag processing
         zero:=list_deep;
         for x:=1 to zero do // check the counters
             if lists[x].read_counter=lists[x].old_value then begin
                dec(list_deep); // decrease list deep
                out_stream2.Seek(lists[x].address,soFromBeginning); // go to counter position
                out_stream2.write(lists[x].write_counter,4); // write counter value
                out_stream2.Seek(0,soFromEnd); // go back to end of stream
             end;
      end;
     // making INFO section
      zero:=0;
      riff_info.name:='LIST'; riff_info.length:=0; list_name:='INFO';
      tags_stream.Write(riff_info,8); // write header "LIST    "
      tags_stream.Write(list_name,4); // write list name "INFO"
      lists[1].address:=tags_stream.Size-8; // remember position of length counter
      lists[1].write_counter:=4;     // initialize write counter
      for x:=0 to IDT_max do add_tags(tags[x],Tags_FourCC[x]); // compile tag information
      tags_stream.Seek(lists[1].address,soFromBeginning); // go to counter position
      tags_stream.write(lists[1].write_counter,4); // write counter value
      // write tags to header or footer
      if tags_stream.Size>12 then begin // there must be at leat one tag in the INFO section
         tags_stream.Seek(0,soFromBeginning); // go to beginning of tags stream
         out_stream1.seek(0,soFromEnd);// go to end of stream
         out_stream2.seek(0,soFromEnd);// go to end of stream
         if out_stream1.size+tags_stream.size>movi_start // if header has not enougth free space for tags
            then out_stream2.CopyFrom(tags_stream,tags_stream.Size) // write to footer
            else out_stream1.CopyFrom(tags_stream,tags_stream.Size); // write to header
      end;
      tags_stream.Clear; // clear INFO tags

      {Compute size of RIFF file (tail start need to be known),
      write this size to the header stream. Fill remain space by JUNK section
      (length of new header must be equal to old size)}
      out_stream1.Seek(4,soFromBeginning); // go to counter position
      zero:=tail_start+out_stream2.size-8; // compute new file size
      out_stream1.write(zero,4); // write RIFF size
      out_stream1.seek(0,soFromEnd);// go to end of stream
      riff_info.name:='JUNK'; riff_info.length:=movi_start-out_stream1.size-8; // create RIFF chunk JUNK
      out_stream1.Write(riff_info,8); // write header of JUNK chunk
      fillchar(buffer,256,0); // fill buffer by zero
      zero:=0; // write JUNK content by 256 bytes peaces
      while zero<riff_info.length do begin
         if (riff_info.length-zero)>256 then x:=256 else x:=riff_info.length-zero;
         out_stream1.write(buffer,x);
         inc(zero,x);
      end;
      {Rewrite file header by the created one. Cut the file at the footer beginning and
      write new footer. That's all!}
      out_stream1.Seek(0,soFromBeginning);  //go to beginning of stream
      seek(in_file,0); //go to beginning of file
      zero:=0; //rewrite from stream to file by 256 bytes blocks
      while zero<out_stream1.Size do begin
         if (out_stream1.size-zero)>256 then x:=256 else x:=out_stream1.size-zero;
         out_stream1.Read(buffer,x);
         inc(zero,x);
         {$I-}blockwrite(in_file,buffer,x);{$I+} //write buffer to file
         if IOResult<>0 then error:=true;
      end;
      out_stream2.Seek(0,soFromBeginning);  //go to beginning of stream
      seek(in_file,tail_start); // go to start of footer
      truncate(in_file); // truncate the file
      zero:=0; // write new footer by 256 bytes blocks
      while zero<out_stream2.Size do begin
         if (out_stream2.size-zero)>256 then x:=256 else x:=out_stream2.size-zero;
         out_stream2.Read(buffer,x);
         inc(zero,x);
         {$I-}blockwrite(in_file,buffer,x);{$I+} //write buffer to file
         if IOResult<>0 then error:=true;
      end;
 {$I-}close(in_file);{$I+}
      if IOResult<>0 then error:=true;
      out_stream1.Destroy;
      out_stream2.Destroy;
      tags_stream.Destroy;

      if error then result:=PE_Write_Error else result:=PE_Parse_Ok;
end;

function TExtendedAVITags.ErrorCodeToStr(Error_Code: HResult): OleVariant;
   const
      Error_Descriptions: array [0..PE_max] of string = (
         'Ok',
         'Errors were ignored',
         'Error while opening file',
         'Error while reading file',
         'File does not match RIFF format',
         'File size is smaller than supposed in RIFF header',
         'File does not match AVI format',
         'Error in AVI structure (wrong chunk size)',
         'Error while closing file',
         'Error while writing to file',
         'Error while seeking file',
         'Memory allocation error'
      );
begin
   if error_code in [0..PE_max] then result:=Error_Descriptions[error_code];
end;

function TExtendedAVITags.NewTagsContainer: OleVariant;
begin
   Result:=OleVariant(VarArrayCreate([0,IDI_max,0,AVI_Info_max],varVariant)); // allocate memory for INFO tags
end;

function TExtendedAVITags.GetInfo(AVI_Info: OleVariant;
  Type_ID: CInfo_Type_ID; Info_ID: SYSINT): OleVariant;
begin
   if not VarIsEmpty(AVI_Info[Type_ID,Info_ID])
      then Result:=AVI_Info[Type_ID,Info_ID]
      else Result:='';
end;

function TExtendedAVITags.SetInfo(var AVI_Info: OleVariant;
  Type_ID: CInfo_Type_ID; Info_ID: SYSINT; New_Value: OleVariant): HResult;
begin
   AVI_Info[Type_ID,Info_ID]:=New_Value;
   Result:=0;
end;

function TExtendedAVITags.FccToStr(FourCC: OleVariant): OleVariant;
var stroka:string;
    fcc_longword:longword;
    fcc:TFourCC;
begin
   stroka:=FourCC;
   delete(stroka,1,2); // delete "0x" from the beginning of the string
   stroka:='$'+stroka; // add "$" at the beginning of the string
   try fcc_longword:=strtoint(stroka); except end; // convert to numeric representation
   Move(fcc_longword,fcc[1],4); // convert to character representation
   stroka:=fcc; // convert to string representation
   result:=stroka;
end;

initialization
  TAutoObjectFactory.Create(ComServer, TExtendedAVITags, Class_ExtendedAVITags,
    ciMultiInstance, tmApartment);

    //ciMultiInstance, tmApartment
    //ciSingleInstance, tmSingle

end.



